/* UW8 - Operator Services src/add_trusted.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<bot.h>

void add_trust(char *who, char *rest)
{
   FILE *hfile;
   struct trustinfo *new, *current;
   char *hostmask, *reason, *nwho, *trusted, *helpname;
   int i=0;

   nwho=nick2num(who);
   helpname = get_command_name("addtrust");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   trusted = strtok(rest, " ");
   current = trusthead;
   while(current != NULL)
   {
      if(!bancmp(current->host, trusted) || !bancmp(trusted, current->host))
      {
         if(!strcasecmp(current->host, trusted))
         {
            send_to_server(":%s NOTICE %s :That Host is already in the trusted list\n", bot.nick, nwho);
            return;
         }
         if(strlen(trusted) < strlen(current->host))
            del_trust(who, current->host);
         else
         {
            send_to_server(":%s NOTICE %s :Trusted Mask already covered by %s\n", bot.nick, nwho, current->host);
            return;
         }
      }
      current = current->next;
   }
   add_trustinfo(trusted);
   send_to_server(":%s NOTICE %s :Trusted Host added\n", bot.nick, nwho);
   write_trustinfo();
}

void del_trust(char *who, char *rest)
{
   FILE *fp, *fp2;
   char buff[300], *trusted, *host, *nwho, *helpname;
   struct trustinfo *current, *previous;

   nwho=nick2num(who);
   helpname = get_command_name("deltrust");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   current = trusthead;
   while(current != NULL)
   {
      if(!strcasecmp(rest, current->host)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      if(current == trusthead) trusthead = trusthead->next;
      else previous->next = current->next;
      free(current);
      send_to_server(":%s NOTICE %s :Trusted Host Removed from list\n", bot.nick, nwho);
      write_trustinfo();
   }
}
