/* UW8 - Operator Services src/chk_access.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include<bot.h>

int check_access(char *who, char *rest, int level, char *cmd)
{
   struct nickinfo *nick;
   struct operinfo *oper;
   char *nwho;

   added_level = 0;
   nwho = nick2num(who);
   oper = return_operinfo(who);
   nick = return_nickinfo(who);
   if(oper != NULL && nick->is_oper)
   {
      if(oper->suspend)
      {
          send_to_server(":%s NOTICE %s :Your %s Access has been suspended\n", bot.nick, nwho, bot.nick);
          return 0;
      }      
      if(level == 0 && nick->is_oper)
      {
         oper->lastseen = time(NULL);
         return 1;
      }
      added_level = oper->level;
      if(oper->level < level)
      {
         send_denied_msg(who);
         return 0;
      }
      oper->lastseen = time(NULL);
      return 1;
   }
   if(level == 0 && nick->is_oper) return 1;
   if(rest == NULL) 
   {
      send_denied_msg(who);
      return 0;
   }
   send_denied_msg(who);
   added_level = 0;
   return 0;
}
