/* UW8 - Operator Services src/collide.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<bot.h>

void collide(char *who, char *rest)
{
   FILE *rfile;
   char *helpname, *nwho, tmp[100],*user, *host, *reason, *usernum;

   nwho = nick2num(who);
   helpname = get_command_name("collide");
   if(rest == NULL || rest[0] == '\0' || strchr(rest,'!') != NULL)
   {
      do_help(who, helpname);
      return;
   }
   if((user = strchr(rest, ' ')) != NULL)  *user++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a user id, read help\n", bot.nick, nwho);
      return;
   }
   if((host = strchr(user, ' ')) != NULL)  *host++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a host, read help\n", bot.nick, nwho);
      return;
   }
   if(strchr(user, '@'))
   {
      do_help(who, helpname);
      return;
   }
   if((reason = strchr(host, ' ')) != NULL) *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a COLLIDE reason, read help\n", bot.nick, nwho);
      return;
   }
   if(strchr(host, '@'))
   {
      do_help(who, helpname);
      return;
   }
   usernum=get_free_usernum(rest);
   send_to_server("%c NICK %s 1 780000000 %s %s DQx8MG %s :%s\n", convert2y[server_num], rest, user, host, usernum, reason);
   send_to_server(":%s NOTICE %s :Cloned user %s!%s@%s\n", bot.nick, nwho, rest, user, host);
}

void clone(char *who, char *rest)
{
   FILE *rfile;
   char *nick, *nwho, tmp[100],*user, *host, *reason, *usernum, *helpname;

   helpname = get_command_name("clone");
   nwho = nick2num(who);
   if(rest == NULL)
   {
      send_to_server(":%s NOTICE %s :I believe you need to review the help\n", bot.nick, nwho);
      return;
   }
   if(rest[0] == '\0')
   {
      send_to_server(":%s NOTICE %s :I believe you need to review the help\n", bot.nick, nwho);
      return;
   }
   if(strchr(rest,'!') != NULL)
   {
      send_to_server(":%s NOTICE %s :Improper Syntax, Please Read Help\n", bot.nick, nwho);
      return;
   }
   if((nick = strchr(rest, ' ')) != NULL)  *nick++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a nick, read help\n", bot.nick, nwho);
      return;
   }
   if((user = strchr(nick, ' ')) != NULL)  *user++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a user id, read help\n", bot.nick, nwho);
      return;
   }
   if((host = strchr(user, ' ')) != NULL)  *host++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a host, read help\n", bot.nick, nwho);
      return;
   }
   if(strchr(user, '@'))
   {
      do_help(who, helpname);
      return;
   }
   if((reason = strchr(host, ' ')) != NULL) *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a channel , read help\n", bot.nick, nwho);
      return;
   }
   if(strchr(host, '@'))
   {
      do_help(who, helpname);
      return;
   }
   usernum=get_free_usernum(rest);
   send_to_server("%c NICK %s 1 780000000 %s %s DQx8MG %s :%s\n", convert2y[server_num], nick, user, host, usernum, reason);
   send_to_server(":%s JOIN %s\n", nick, rest);
   send_to_server(":%s MODE %s +o %s\n", myserver, rest, usernum);
   send_to_server(":%s NOTICE %s :Cloned user %s!%s@%s\n", bot.nick, nwho, nick, user, host);
   send_to_server(":%s MODE %s +d\n", nick, nick);
}
