/* UW8 - Operator Services src/free_lists.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include <bot.h>

void free_maplist()
{
   struct mapinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Maplist\n", date());
   current = maphead;
   while(current != NULL)
   {
      if(current == maphead) maphead = maphead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_hublist()
{
   struct hubinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Hublist\n", date());
   current = hubhead;
   while(current != NULL)
   {
      if(current == hubhead) hubhead = hubhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_templist()
{
   struct templist *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing templist\n", date());
   current = listhead;
   while(current != NULL)
   {
      if(current == listhead) listhead = listhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_nicklist()
{
   struct nickinfo *nick, *tmp;
   struct chaninfo *chan, *tmp1;
   log(ERRLOG_FILE, "[%s] Freeing nicklist\n", date());
   nick = nickhead;
   chan = nick->chanhead;
   while(nick != NULL)
   {
      while(chan != NULL)
      {
         if(chan == nick->chanhead) nick->chanhead = nick->chanhead->next;
         tmp1 = chan->next;
         free(chan);
         chan=tmp1;
      }
      if(nick == nickhead) nickhead = nickhead->next;
      tmp = nick->next;
      free(nick);
      nick=tmp;
   }
}

void free_operinfo()
{
   struct operinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing operlist\n", date());
   current = operhead;
   while(current != NULL)
   {
      if(current == operhead) operhead = operhead->next;
      tmp=current->next;
      free(current);
      current=tmp;
   }
}

void free_ginfo()
{
   struct ginfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing glinelist\n", date());
   current = ghead;
   while(current != NULL)
   {
      if(current == ghead) ghead = ghead->next;
      tmp=current->next;
      free(current);
      current=tmp;
   }
}

void free_jupeinfo()
{
   struct jupeinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing jupelist\n", date());
   current = jupehead;
   while(current != NULL)
   {
      if(current == jupehead) jupehead = jupehead->next;
      tmp=current->next;
      free(current);
      current=tmp;
   }
}

void free_resvinfo()
{
   struct resvinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing resvlist\n", date());
   current = resvhead;
   while(current != NULL)
   {
      if(current == resvhead) resvhead = resvhead->next;
      tmp=current->next;
      free(current);
      current=tmp;
   }
}

void free_hostchk()
{
   struct hostchk *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing hostchk\n", date());
   current = hosthead;
   while(current != NULL)
   {
      if(current == hosthead) hosthead = hosthead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_trusted()
{
   struct trustinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing trusted\n", date());
   current = trusthead;
   while(current != NULL)
   {
      if(current == trusthead) trusthead = trusthead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_secret()
{
   struct secretinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing Secret\n", date());
   current = secrethead;
   while(current != NULL)
   {
      if(current == secrethead) secrethead = secrethead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}

void free_badchan()
{
   struct badinfo *current, *tmp;
   log(ERRLOG_FILE, "[%s] Freeing trusted\n", date());
   current = badhead;
   while(current != NULL)
   {
      if(current == badhead) badhead = badhead->next;
      tmp = current->next;
      free(current);
      current=tmp;
   }
}
