/* UW8 - Operator Services src/jupe.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<bot.h>

void jupe(char *who, char *rest)
{
   FILE *jfile;
   char *reason, *nwho, *tmpnum, srvnum, *helpname;
   int i=0, numeric;

   nwho=nick2num(who);
   helpname = get_command_name("jupe");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   if((tmpnum = strchr(rest, ' ')) != NULL) *tmpnum++ = '\0';
   else
   {
      do_help(who, helpname);
      return;
   }
   if(strchr(rest, '*'))
   {
      send_to_server(":%s NOTICE %s :No wildcards.  Use full server name\n", bot.nick, nwho);
      return;
   }
   if(!strchr(rest, '.'))
   {
      send_to_server(":%s NOTICE %s :Invalid server specification\n", bot.nick, nwho);
      return;
   }
   if((reason = strchr(tmpnum, ' ')) != NULL) *reason++ = '\0';
   else   
   {         
      send_to_server(":%s NOTICE %s :You must specify a JUPE reason, read help\n", bot.nick, nwho);
      return;
   }
   send_to_server("%c SQUIT %s :Juped by %s\n",convert2y[server_num], rest, who);
   send_to_server("%c SQUIT %s 0 :Juped by %s\n",convert2y[server_num], rest, who);
   serv_unused(rest);
   numeric = atoi(tmpnum);
   srvnum=get_free_servnum(rest, convert2y[numeric]);
   if(srvnum == '\0')
   {
      send_to_server(":%s NOTICE %s :The numeric you specified is in use, please try another\n", bot.nick, nwho);
      return;
   }
   send_to_server("%c SERVER %s %d 0 %ld P10 %cD] :JUPE - %s\n",convert2y[server_num], rest, HOPCOUNT + 1, time(NULL), srvnum, reason);
   add_jupeinfo(who, rest, numeric, reason);
   write_jupe();
}

void unjupe(char *who, char *rest)
{
   struct jupeinfo *current, *previous;
   char *serv, *nwho, *helpname;

   nwho = nick2num(who);
   helpname = get_command_name("reserve");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   serv = strtok(rest, " ");
   current = jupehead;
   while(current != NULL)
   {
      if(!strcasecmp(serv, current->server)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      if(current == jupehead) jupehead = jupehead->next;
      else previous->next = current->next;
      free(current);
      send_to_server("%c SQUIT %s :Juped Removed by %s\n",convert2y[server_num], rest, who);
      send_to_server("%c SQUIT %s 0 :Juped Removed by %s\n",convert2y[server_num], rest, who);
      serv_unused(rest);
   }
   write_jupe();
}  
