/* UW8 - Operator Services src/parse_privmsg.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <bot.h>

void parse_privmsg(char *who, char *rest)
{
   /* rest = bot.nick :command #channel arg1 arg2 etc */
   int i;
   char *msg, *cmd, *nwho, *helpname;

   nwho=nick2num(who);
   if(check_flood(who)) return;  /* you flooding me? go away! */
   trailing_blanks(rest);        /* get rid of those trailing blanks */
   if(cmd = strchr(rest, ':')) *cmd++ = '\0';
   else return;
   if(msg = strchr(cmd, ' ')) *msg++ = '\0';
   else msg = NULL;
   if(msg != NULL && *msg == ' ')
   {
      send_to_server(":%s NOTICE %s :You have to many spaces directly after the command.\n", bot.nick, nwho, cmd);
      return;
   }
   if(strlen(cmd) > 99)
   {
       return;
   }
#ifdef DEBUG
printf("Parse Privmsg - Command: [%s] Who: [%s] Msg: [%s]\n", cmd, who, msg);
#endif
   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(commands[i].name, cmd))
      {
         if(commands[i].disable)
         {
             send_to_server(":%s NOTICE %s :The command %s has been disabled.\n", bot.nick, nwho, cmd);
             return;
         }
         if(commands[i].needarg && msg == NULL)
         {
            do_help(who, cmd);
            return;
         }
         if(!check_access(who, msg, commands[i].level, cmd)) return;
         command_log(who, cmd, rest);
         commands[i].function(who, msg);
         return;
      }
   }
   send_to_server(":%s NOTICE %s :The Command [ %s ] is not a proper command.\n", bot.nick, nwho, cmd);
   send_to_server(":%s NOTICE %s :Please ensure you typed it correctly.\n", bot.nick, nwho);
}
