/* UW8 - Operator Services src/reserve.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<bot.h>

void reserve(char *who, char *rest)
{
   FILE *rfile;
   char *nwho, tmp[300], *nick, *user, *host, *reason, *chknick, *usernum, *helpname;
   int i=0;

   nwho = nick2num(who);
   helpname = get_command_name("reserve");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   if((user = strchr(rest, ' ')) != NULL)  *user++ = '\0';
   else   
   {         
      do_help(who, helpname);
      return;
   }
   if((host = strchr(user, ' ')) != NULL)  *host++ = '\0';
   else   
   {         
      do_help(who, helpname);
      return;
   }
   if(strchr(user, '@'))
   {
      do_help(who, helpname);
      return;
   }
   if((reason = strchr(host, ' ')) != NULL) *reason++ = '\0';
   else   
   {         
      do_help(who, helpname);
      return;
   }
   if(strchr(host, '@'))
   {
      do_help(who, helpname);
      return;
   }
   if(creserve(rest))
   {
      send_to_server(":%s NOTICE %s :That nick is already reserved\n", bot.nick, nwho);
      return;
   }
   usernum=get_free_usernum(rest);
   add_resvinfo(rest, user, host, reason);
   send_to_server("%c NICK %s 1 780000000 %s %s DQx8MG %s :JUPE - %s\n", convert2y[server_num], rest, user, host, usernum, reason);
   send_to_server(":%s NOTICE %s :Cloned user %s!%s@%s\n", bot.nick, nwho, rest, user, host);
   write_reserve();
}

int creserve(char *who)
{
   char *nick, *user, *host, *reason;
   char buff[300];
   struct resvinfo *resv;

   resv = resvhead;
   while(resv != NULL)
   {
      if(!strcasecmp(who, resv->nick)) return 1;
      resv = resv->next;
   }
   return 0;
}
void unreserve(char *who, char *rest)
{
   struct resvinfo *current, *previous;
   FILE *fp, *fp2;
   char *nick, *usernum, *helpname;
   char *nwho;

   nwho = nick2num(who);
   helpname = get_command_name("unreserve");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   nick = strtok(rest, " ");
   current = resvhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick, current->nick)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      if(current == resvhead) resvhead = resvhead->next;
      else previous->next = current->next;
      free(current);
      usernum=get_usernum(rest);
      delete_usernum(usernum);
      send_to_server(":%s QUIT :%s\n", nick, "Removing Reserved Nick");
      send_to_server(":%s NOTICE %s :Reservered Nick %s removed\n", bot.nick, nwho, nick);
      write_reserve();
   }
}
