/* UW8 - Operator Services src/ret_operinfo.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include<bot.h>

struct operinfo *return_operinfo(char *who)
{
   struct operinfo *current1;
   struct adderinfo *current2;
   int bool = 0;
   char *uhost;
   
   uhost = getnickuserhost(who);
   if(uhost == NULL) return NULL;
   current1 = operhead;
   while(current1 != NULL) 
   {
      current2 = current1->adderhead;
      while(current2 != NULL)
      {
         collapse(uhost);
         if(!bancmp(uhost, current2->address) || !bancmp(current2->address, uhost))
         {
            return current1;
         }
         current2 = current2->next;
      }
      current1 = current1->next;
   }
   return NULL;
}


struct adderinfo *ret_oper_addrinfo(char *who, char *chan)
{
   struct operinfo *current1;
   struct adderinfo *current2;

         current1 = operhead;
         while(current1 != NULL) 
         {
            current2 = current1->adderhead;
            while(current2 != NULL)
            {
               collapse(who);
               if(!bancmp(current2->address, who) || !bancmp(who, current2->address))
               {
                  if(current1->suspend == TRUE) return NULL;
                  return current2;
               }
               current2 = current2->next;
            }
            current1 = current1->next;
         }
   return NULL;
}

struct operinfo *ret_oper_level(char *who)
{
   struct operinfo *current1;
         current1 = operhead;
         while(current1 != NULL) 
         {
            if(!strcasecmp(who, current1->nick)) 
            {
               return current1;
            }
            current1 = current1->next;
         }
   return NULL;
}

struct nickinfo *return_chaninfo(char *nick, char *channel)
{
   struct nickinfo *current;
   struct chaninfo *chan;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick,current->nick))
      {
         chan = current->chanhead;
         while(chan != NULL)
         {
            if(!strcasecmp(channel, chan->channel))
            {
               return current;
            }
            chan = chan->next;
         }
      }
      current = current->next;
   }
   return NULL;
}

struct nickinfo *return_nickinfo(char *nick)
{
   struct nickinfo *current;
   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(nick,current->nick))
      {
         return current;
      }
      current = current->next;
   }
   return NULL;
}

struct operinfo *ret_oper_operinfo(char *who)
{
   struct operinfo *current1;
   current1 = operhead;
   while(current1 != NULL)
   {
      if(!strcasecmp(who, current1->nick))
      {
         return current1;
      }
      current1 = current1->next;
   }
   return NULL;
}
