/* UW8 - Operator Services src/show_access.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include<bot.h>

void show_access(char *who, char *rest)
{
   struct operinfo *oper;
   struct adderinfo *addr, *tmp;
   char *aut = "OFF", *prot = "OFF", *suspend = "OFF", *helpname;
   char *nwho, *nick, sbuff1[1000], sbuff[1000], buff[1000], test[100];
   int howmany = 0;
   
   helpname = get_command_name("access");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   buff[0] = '\0';
   sbuff[0] = '\0';
   nick = strtok(rest, " ");
   if(nick == NULL)
   {
      do_help(who, helpname);
      return;
   }
   nwho = nick2num(who);

   if((nick[0] == '>' || nick[0] == '<' || nick[0] == '=') && nick[1] == ' ')
   {   
       send_to_server(":%s NOTICE %s : There should be no space after the < or > or = sign \n", bot.nick, nwho);
       return;
   }   
   if((nick[0] == '>' || nick[0] == '<' || nick[0] == '=') && !isdigit(nick[1]))
   {   
       send_to_server(":%s NOTICE %s : The level value must be a number < or > sign \n", bot.nick, nwho);
       return;
   }   
   if(nick[0] == '>')
   {
            *nick++;
            oper = operhead;
            while(oper != NULL)
            {
               if(atoi(nick) < oper->level)
               {
                  if(oper->suspend == 0) suspend = "\0034OFF\003";
                  else suspend = "\0033ON\003";
                  send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
                  send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
                  sbuff[0] = '\0';
                  buff[0] = '\0';
                  howmany++;
                  addr = oper->adderhead;
                  while(addr != NULL)
                  {
                     sprintf(sbuff, "%s  ", addr->address);
                     strcat(buff, sbuff);
                     addr = addr->next;
                  }
                  send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
                  send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
               }    
               oper = oper->next;
            }
      return;
   }
   if(nick[0] == '<')
   {
            *nick++;
            oper = operhead;
            while(oper != NULL)
            {
               if(atoi(nick) > oper->level)
               {
                  if(oper->suspend == 0) suspend = "\0034OFF\003";
                  else suspend = "\0033ON\003";
                  send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
                  send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
                  sbuff[0] = '\0';
                  buff[0] = '\0';
                  howmany++;
                  addr = oper->adderhead;
                  while(addr != NULL)
                  {
                     sprintf(sbuff, "%s  ", addr->address);
                     strcat(buff, sbuff);
                     addr = addr->next;
                  }
                  send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
                  send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
               }    
               oper = oper->next;
            }
      return;
   }
   if(nick[0] == '=')
   {
            *nick++;
            oper = operhead;
            while(oper != NULL)
            {
               sbuff[0] == '\0';
               buff[0] == '\0';
               if(atoi(nick) == oper->level)
               {
                  if(oper->suspend == 0) suspend = "\0034OFF\003";
                  else suspend = "\0033ON\003";
                  send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
                  send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
                  sbuff[0] = '\0';
                  buff[0] = '\0';
                  howmany++;
                  addr = oper->adderhead;
                  while(addr != NULL)
                  {
                     sprintf(sbuff, "%s  ", addr->address);
                     strcat(buff, sbuff);
                     addr = addr->next;
                  }
                  send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
                  send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
               }    
               oper = oper->next;
            }
      return;
   }
   sprintf(sbuff1, "*%s*", nick);
         oper = operhead;
         while(oper != NULL)
         {
            if(!strchr(nick, '@') && !strchr(nick, '*'))
            {
               if(!wcmp(sbuff1, oper->nick))
               {
                  if(oper->suspend == 0) suspend = "\0034OFF\003";
                  else suspend = "\0033ON\003";
                  send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level,  suspend);
                  send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
                  sbuff[0] = '\0';
                  buff[0] = '\0';
                  howmany++;
                  addr = oper->adderhead;
                  while(addr != NULL)
                  {
                     sprintf(sbuff, "%s  ", addr->address);
                     strcat(buff, sbuff);
                     addr = addr->next;
                  }
                  send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
                  send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
               }
            }
            else if(!strchr(nick, '@') && strchr(nick, '*'))
            {
               if(!wcmp(nick, oper->nick))
               {
                  if(oper->suspend == 0) suspend = "\0034OFF\003";
                  else suspend = "\0033ON\003";
                  send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
                  send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
                  sbuff[0] = '\0';
                  buff[0] = '\0';
                  howmany++;
                  addr = oper->adderhead;
                  while(addr != NULL)
                  {
                     sprintf(sbuff, "%s  ", addr->address);
                     strcat(buff, sbuff);
                     addr = addr->next;
                  }
                  send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
                  send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
               }
            }
            else
            {
               collapse(nick);
               addr = oper->adderhead;
               while(addr != NULL)
               {
                  if(!bancmp(nick, addr->address) || !bancmp(addr->address, nick))
                  {
                     if(oper->suspend == 0) suspend = "\0034OFF\003";
                     else suspend = "\0033ON\003";
                     send_to_server(":%s NOTICE %s : \0031Profile: [\003\00312 %s\003\0031 ] [\003\0034 %d\003\0031 ] \0031Suspend:\003 %s\n", bot.nick, nwho, oper->nick, oper->level, suspend);
                     send_to_server(":%s NOTICE %s : \0031LastSeen: \003\0034 %s\003\n", bot.nick, nwho, get_time(oper->lastseen));
                     sbuff[0] = '\0';
                     buff[0] = '\0';
                     howmany++;
                     addr = oper->adderhead;
                     while(addr != NULL)
                     {
                        sprintf(sbuff, "%s  ", addr->address);
                        strcat(buff, sbuff);
                        addr = addr->next;
                     }
                     send_to_server(":%s NOTICE %s : \0031Masks:\003\0032 %s\003\n", bot.nick, nwho, buff);
                     send_to_server(":%s NOTICE %s : -\n", bot.nick, nwho);
                     break;
                  }
                  addr = addr->next;
               }
            }
            oper = oper->next;
         }
      return;
}
